﻿<html>
  <head>
    <title>Phaser Einführung</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <link rel=stylesheet href=index.css>
    <script src="phaser.min.js"></script>
  </head>
  <body>
    <a href="http://phaser.io" target=blank><span class=header> Phaser HTML5 Framework - Version 3 </span></a>
    <div id=stuff>
        <div class=main><a href="http://labs.phaser.io/index.html" target=blank> Phaser3<br>Examples </a></div>
        <div class=main><a href="https://photonstorm.github.io/phaser3-docs/index.html" target=blank> Phaser<br>Documentation </a></div>
        <div class=main><a href="https://photonstorm.github.io/phaser3-docs/Phaser.Physics.Arcade.html" target=blank> Phaser.Physics.Arcade<br>Docs </a></div>
        <div class=main><a href="https://photonstorm.github.io/phaser3-docs/Phaser.Physics.Arcade.Body.html" target=blank> Phaser.Physics.Arcade.Body Docs</a></div>
        <div class="main"><a href="http://www.html5gamedevs.com/forum/33-phaser-3/" target=blank> Phaser<br>Game Devs </a></div><br>
        <div class="main"><a href="#" onclick="location.reload();" > reload <br><br></a></div>
    </div>

<!--     the parent container for our rendering canvas -->
    <div id=preview name=preview ></div>


<script type="text/javascript">

// the phaser.game config object
var config = {
    type: Phaser.AUTO,  // Which renderer to use
    width: 800,         // Canvas width in pixels
    height: 480,        // Canvas height in pixels
    parent:"preview",   // ID of the DOM element to add the canvas to
    physics: {
        default: 'arcade',       // Which physics engine to use
        arcade: {
            gravity: { y: 1200 },
            debug: false              // paint debug information (hitboxes)
        }
    }
};

var clouds, green, darkgreen;  // global.. yeah
var player, camera, cursors,jumpkey;
var map, platforms, movingplatform1, movingplatform2;
var level, flag;
var music, stageclear;
var stars, scoreText;
var score;




// this scene is only for preloading things (perhaps a loading progressbar would be nice)
// class Preload extends Phaser.Scene - and "constructor () with keyname not needed because "game.scene.add" does all of this
class Preload {
    preload () {
        this.load.image('clouds', 'assets/clouds.png');
        this.load.image('darkgreen', 'assets/darkgreen.png');
        this.load.image('green', 'assets/green.png');
        this.load.image('coin', 'assets/coin.png');
        this.load.image('platform', 'assets/cloud-platform.png');
        this.load.image('ground', 'assets/ground.png');
        this.load.image('flag','assets/flag.png');
        this.load.spritesheet('mario', 'assets/mariospritesheet.png', { frameWidth: 50, frameHeight: 50 });

        this.load.audio('jump', 'assets/jump.ogg');
        this.load.audio('coinsound', 'assets/coin.ogg');
        this.load.audio('theme', 'assets/mariotheme.ogg');
        this.load.audio('clear', 'assets/stageclear.ogg');

        this.load.tilemapTiledJSON('map', 'assets/level1.json');
        this.load.image('tileset', 'assets/tileset.png');
    }
    create (){
        music = this.sound.add('theme',{loop:true});
        stageclear = this.sound.add('clear');
        this.scene.start("1");
    }
}





class Level1 {
//runs once - preloads images, soundfiles, maps



    // runs once after preload - create world here
    create () {
        level = this;
        score = 0;
        if (!music.isPlaying){  music.play();     }


        //tilemap, layer and backgrounds
        map = this.make.tilemap({ key: 'map' });

        clouds = this.add.tileSprite(0, 0,map.widthInPixels,map.heightInPixels, 'clouds').setOrigin(0,0);
        green = this.add.tileSprite(0, map.heightInPixels-640, map.widthInPixels, 640, 'green').setOrigin(0,0);
        darkgreen = this.add.tileSprite(0, map.heightInPixels-480, map.widthInPixels, 480, 'darkgreen').setOrigin(0,0);

        var floorTiles = map.addTilesetImage('tileset');
        var floorLayer = map.createDynamicLayer('floor', floorTiles, 0, 0);
        floorLayer.setCollisionBetween(1, 256);
        var backgroundLayer = map.createDynamicLayer('background',floorTiles, 0, 0);
        var enemyLayer = map.createDynamicLayer('enemies', floorTiles, 0, 0);
        enemyLayer.setTileIndexCallback([81,82], playerDie, this);        // This will set Tile ID 81 to call the function "playerDie" when collided with


        // moving plattforms
        var movingplatform1 = this.physics.add.image(100, 800, 'platform')
        movingplatform1.body.setImmovable(true).setAllowGravity(false);

        var movingplatform2 = this.physics.add.image(500, 600, 'platform')
        movingplatform2.body.setImmovable(true).setAllowGravity(false);


        // automagically move things with tweens
        this.tweens.add({
            targets: movingplatform1,
            y:1000,
            duration: 2000,
            ease: 'Sine.easeInOu',
            yoyo: true,
            repeat: -1,
        });

        this.tweens.add({
            targets:  movingplatform2,
            y: 1000,
            duration: 4000,
            ease: 'Sine.easeInOu',
            yoyo: true,
            repeat: -1,
        });

        // STARS and Score ! something to collect
        stars = this.physics.add.group({
            key: 'coin',
            repeat: 20,
            setXY: { x: 400, y: 500, stepX: 13 }
        });
        stars.children.iterate(function (child) {
            child.setBounceY(Phaser.Math.FloatBetween(0.4, 0.8));
            child.setSize(25, 25, true);      // The 'true' argument means "center it on the gameobject"
            child.setScale(0.5);
        });
        scoreText = this.add.text(16, 16, 'Score: 0', { fontSize: '32px', fill: '#000' });
        scoreText.setScrollFactor(0);




       //camera viewport and worldsize   // wold bounds need to be set (startx,starty, endx,endy, top, right, down , left
        this.physics.world.setBounds(0, 0, map.widthInPixels, map.heightInPixels,128, true, true, false, true);
        camera =  this.cameras.main;
        camera.setBounds(0, 0, map.widthInPixels, map.heightInPixels);


        //player settings
        player = this.physics.add.sprite(250,map.heightInPixels-350,'mario');
        player.setCollideWorldBounds(true);
        player.body.setCircle(24);
        player.body.setMaxVelocity(500,1000);  //the player will fall through plattforms if gravity is accelerating it to more than 1000px/s
        camera.startFollow(player, true, 0.05, 0.05)
        this.anims.create({
            key: 'walk',
            frames: this.anims.generateFrameNumbers('mario', { frames: [1, 2, 3, 4, 3, 2 ] }),
            frameRate: 16
        });


        // Finishline
        flag = this.physics.add.sprite(map.widthInPixels-2500, 850, 'flag');
        flag.body.allowGravity = true;
        flag.body.immovable = true;
        flag.setSize(10, 300);
        flag.setOffset(98,70);




        //controls and camera
        cursors = this.input.keyboard.createCursorKeys();
        jumpkey = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.SPACE);


        //some platforms an other game objects
        platforms = this.physics.add.staticGroup();
        platforms.create(300, 1000, 'platform');
        platforms.create(550, 250, 'platform');
    //     platforms.create(250, game.config.height-64, 'ground');


        // colliders
        this.physics.add.collider(player, platforms);

        this.physics.add.collider(player, movingplatform1, mptouchedown);
        this.physics.add.collider(player, movingplatform2, mptouchedown);
        this.physics.add.collider(stars, floorLayer);

        // overlap checks need to be made after colliders !!
        this.physics.add.overlap(player, enemyLayer, null, null, this); // object1, object2, collideCallback, processCallback, callbackContext)
        this.physics.add.overlap(player, flag, finishit, null, this);
        this.physics.add.overlap(player, stars, collectStar, null, this);


    }


    // runs 60times per second - everything that needs updates goes here..
    update (){

        if (cursors.left.isDown)    {
            player.anims.play('walk', true);
            player.setFlipX(true);
            player.setVelocityX(-400);
        }
        else if (cursors.right.isDown)  {
            player.anims.play('walk', true);
            player.setVelocityX(400);
            player.setFlipX(false);
        }
        else    {
            player.setVelocityX(0);
            player.setFrame(0);
        }


        if (jumpkey.isDown && (player.body.onFloor()) )  {
            player.setVelocityY(-700);
            this.sound.play('jump');
        }
        if (!player.body.onFloor() && jumpkey.isDown ){ player.setFrame(5); }
        if (player.body.y > map.heightInPixels) { playerDie();}

        // parallax
        green.x= camera.scrollX*0.5;
        darkgreen.x= camera.scrollX*0.3;
        clouds.x= camera.scrollX*0.8;
    }
}






// finish scene
class Finished {
    create (){
        clouds = this.add.tileSprite(0, 0, game.config.width* 2, game.config.height* 2, 'clouds').setOrigin(0,0);
        var scoreText = this.add.text(game.config.width/2, game.config.height/2, 'Finished!', { fontSize: '32px', fill: '#000' });
        scoreText.x -= scoreText.width/2;

        music.stop()
        stageclear.play();
    }
}




function collectStar (player, star) {
    star.disableBody(true, true);
    sicore += 10;
    scoreText.setText('Score: ' + score);
    this.sound.play('coinsound');
}



function mptouchedown(mplayer,mplatform) {
    if (mplatform.body.touching.up && mplayer.body.touching.down) {
        mplayer.body.blocked.down = true;   // a dynamic sprite does not set onFloor(sprite.body.blocked.down) to true - so we do it manually
    }
}




function finishit() {
    this.scene.stop("1");
    this.scene.start("finished");
    this.sound.play('coinsound1');
}

function playerDie() {
     level.scene.restart(true);  // true - clear all
}


var game = new Phaser.Game(config);  //our game instance - using the config object
game.scene.add("1", Level1);
game.scene.add("finished", Finished);
game.scene.add("preload", Preload);

game.scene.start("preload");




</script>
  </body>
</html>
